Index: branches/terrain/src/lib/graphics/effects/volfog_effect.cc
===================================================================
--- branches/terrain/src/lib/graphics/effects/volfog_effect.cc	(revision 9413)
+++ branches/terrain/src/lib/graphics/effects/volfog_effect.cc	(revision 9414)
@@ -30,5 +30,5 @@
 //#include <GL/glext.h> //OpenGL Extensions
 //#include <GL/glxext.h> // GLX Extensions
-
+#ifndef __APPLE__
 #ifndef GL_EXT_fog_coord
 #define GL_EXT_fog_coord 1
@@ -45,5 +45,5 @@
 PFNGLFOGCOORDDVEXTPROC glFogCoorddvEXT = 0;
 PFNGLFOGCOORDPOINTEREXTPROC glFogCoordPointerEXT = 0;
-
+#endif
 
 
Index: branches/terrain/src/lib/graphics/importer/Makefile.am
===================================================================
--- branches/terrain/src/lib/graphics/importer/Makefile.am	(revision 9413)
+++ branches/terrain/src/lib/graphics/importer/Makefile.am	(revision 9414)
@@ -38,7 +38,11 @@
                            md3/md3_mesh.cc \
                            md3/md3_data.cc \
-                           md3/md3_tag.cc
-
-
+                           md3/md3_tag.cc \
+			   \
+                           terrain/terrain.cc \
+                           terrain/terrain_quad.cc \
+                           terrain/terrain_page.cc \
+                           terrain/frustum.cc \
+                           terrain/buffer_broker.cc
 
 
@@ -81,4 +85,11 @@
                 md3/md3_mesh.h \
                 md3/md3_data.h \
-                md3/md3_tag.h
+                md3/md3_tag.h \
+                \
+		terrain/terrain.h \
+		terrain/terrain_page.h \
+		terrain/terrain_quad.h \
+		terrain/frustum.h \
+		terrain/types.h \
+                terrain/buffer_broker.h
 
Index: branches/terrain/src/lib/graphics/importer/bsp_file.cc
===================================================================
--- branches/terrain/src/lib/graphics/importer/bsp_file.cc	(revision 9413)
+++ branches/terrain/src/lib/graphics/importer/bsp_file.cc	(revision 9414)
@@ -21,9 +21,9 @@
 #include "bsp_file.h"
 #include "bsp_tree_node.h"
-#include <fstream>
 #include "util/loading/resource_manager.h"
-
+#include <string>
 #include <sys/stat.h>
 #include <string.h>
+#include "filesys/binary_file.h"
 #include "debug.h"
 #include "material.h"
@@ -40,6 +40,17 @@
 #include <vector>
 
-
-
+using namespace std;
+
+static const char* HEADER_SEMANTICS  		= "b4i35";
+static const char* NODE_SEMANTICS  			= "i9";
+static const char* LEAF_SEMANTICS  			= "i12";
+static const char* MODEL_SEMANTICS			= "i10";
+static const char* BRUSH_SEMANTICS  		= "i3";
+static const char* BRUSHSIDE_SEMANTICS  	= "i2";
+static const char* FACE_SEMANTICS  			= "i26";
+static const char* VERTEX_SEMANTICS  		= "i10b4";
+static const char* LIGHTMAP_SEMANTICS 		= "b49152";
+static const char* TEXTURE_SEMANTICS 		= "b64i2";
+static const char* PLANE_SEMANTICS 			= "f4";
 
 // Constructor
@@ -81,5 +92,166 @@
 
 }
-
+void BspFile::readEntities()
+{
+	/* We do nothing here */
+}
+void BspFile::readTextures()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Textures];
+	this->numTextures = lump.length/sizeof(BspTexture);
+	this->textures = new char[lump.length];
+	file.seekg( lump.offset );	
+	file.read( TEXTURE_SEMANTICS, this->numTextures, 
+		this->textures, slurpedBytes );
+}
+void BspFile::readPlanes()
+{	
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Planes];
+	this->numPlanes = lump.length/sizeof(plane);
+	this->planes = new plane[this->numPlanes];
+	file.seekg( lump.offset );
+	file.read( PLANE_SEMANTICS, this->numPlanes, 
+		this->planes, slurpedBytes );
+}
+
+void BspFile::readNodes()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Nodes];
+	this->numNodes = lump.length/sizeof(node);
+	this->nodes = new node[this->numNodes];
+	file.seekg( lump.offset );
+	file.read( NODE_SEMANTICS, this->numNodes, 
+		this->nodes, slurpedBytes );
+}
+
+void BspFile::readLeafs()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Leafs];
+	this->numLeafs = lump.length/sizeof(leaf);
+	this->leaves = new leaf[this->numLeafs];
+	file.seekg( lump.offset );
+	file.read( LEAF_SEMANTICS, this->numLeafs, 
+		this->leaves, slurpedBytes );	
+}
+
+void BspFile::readLeafFaces()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Leaffaces];
+	this->numLeafFaces = lump.length/sizeof(int);
+	this->leafFaces = (char*)( new int[this->numLeafFaces] );
+	file.seekg( lump.offset );
+	file.read( "i", this->numLeafFaces, 
+		this->leafFaces, slurpedBytes );
+}
+
+void BspFile::readLeafBrushes()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Leafbrushes];
+	this->numLeafBrushes = lump.length/sizeof(int);
+	this->leafBrushes = (char*) ( new int[this->numLeafBrushes] );
+	file.seekg( lump.offset );
+	file.read( "i", this->numLeafBrushes, 
+		this->leafBrushes, slurpedBytes );	
+}
+
+void BspFile::readModels()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Models];
+	this->numBspModels = lump.length/sizeof(model);
+	this->bspModels = new model[this->numBspModels];
+	file.seekg( lump.offset );
+	file.read( MODEL_SEMANTICS, this->numBspModels, 
+		this->bspModels, slurpedBytes );
+}
+
+void BspFile::readBrushes()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Brushes];
+	int numBrushes = lump.length/sizeof(brush);
+	this->brushes = new brush[numBrushes];
+	file.seekg( lump.offset );
+	file.read( BRUSH_SEMANTICS, numBrushes, 
+		this->brushes, slurpedBytes );
+}
+void BspFile::readVertices()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Vertices];
+	this->numVertex = lump.length/sizeof(BspVertex);
+	this->vertice = (char*)( new BspVertex[this->numVertex] );
+	file.seekg( lump.offset );
+	file.read( VERTEX_SEMANTICS, this->numVertex, 
+		this->vertice, slurpedBytes );
+}
+
+void BspFile::readMeshVerts()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Meshverts];
+	int num = lump.length / sizeof( meshvert );
+	this->meshverts = new meshvert[num];
+	file.seekg( lump.offset );
+	file.read( "i", num, this->meshverts, slurpedBytes );
+}
+
+void BspFile::readEffects()
+{
+	/* not loaded atm */
+}
+
+void BspFile::readFaces()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Faces];
+	this->numFaces = lump.length/sizeof(face);
+	this->faces = new face[this->numFaces];
+	file.seekg( lump.offset );
+	file.read( FACE_SEMANTICS, this->numFaces, 
+		this->faces, slurpedBytes );
+}
+
+void BspFile::readLightmaps()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Lightmaps];
+	this->numLightMaps = lump.length/sizeof(lightmap);
+	this->lightMaps = new lightmap[this->numLightMaps];
+	file.seekg( lump.offset );
+	file.read( LIGHTMAP_SEMANTICS, this->numLightMaps, 
+		this->lightMaps, slurpedBytes );
+}
+void BspFile::readLightvols()
+{
+	/* not loaded atm */	
+}
+void BspFile::readBrushSides()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Brushsides];
+	this->numBrushSides = lump.length/sizeof(brushside);
+	printf( "numBrushSides: %d\n", numBrushSides );
+	this->brushSides = new brushside[this->numBrushSides];
+	file.seekg( lump.offset );
+	file.read( BRUSHSIDE_SEMANTICS, this->numBrushSides, 
+		this->brushSides, slurpedBytes );
+}
+void BspFile::readVisdata()
+{
+	size_t slurpedBytes;
+	bsp_lump& lump = header.lumps[Visdata];
+	this->visData = new char[lump.length];
+	file.seekg( lump.offset );
+	file.read( "i2", 1, this->visData, slurpedBytes );
+	file.read( "b", lump.length-8, 
+		this->visData+8, slurpedBytes );	
+}
 /**
  *  Loads a quake3 level (*.bsp)
@@ -88,269 +260,111 @@
 int BspFile::read(const char* name)
 {
-  this->scale = 1.0;
-  int offset;
-  int size;
-  struct stat results;
-
-
-  if (stat( name , &results) == 0) {
-    PRINTF(0)("BSP FILE: Datei %s gefunden. \n", name);
-    std::ifstream bspFile (name, std::ios::in | std::ios::binary);
-    bspFile.read(this->header, 260);
-    PRINTF(0)("BSP FILE: BSPVersion: %i. \n", ((int *)(header) )[1]);
-    if(SDL_SwapLE32(((int *)(header) )[1]) == 46)    PRINTF(0)("BSP FILE: This is the good one! :-)  \n");
-    else  PRINTF(0)("BSP FILE: Wrong BSPVersion.\n");   //!< now, we should do some error handling
-
-    // Get the Nodes
-    offset = SDL_SwapLE32(((int *)(header) )[8]);
-    size    = SDL_SwapLE32(((int *)(header))[9]);
-    PRINTF(4)("BSP FILE: NodeSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumNodes: %i. \n", size / sizeof(node));
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % sizeof(node));
-    PRINTF(4)("BSP FILE: NodeOffset: %i. \n", offset);
-    this->numNodes = size/sizeof(node);
-    this->nodes = new node [this->numNodes];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->nodes, size);
-
-    // and their Planes
-    offset = SDL_SwapLE32(((int *)(header) )[6]);
-    size    = SDL_SwapLE32(((int *)(header))[7]);
-    PRINTF(4)("BSP FILE: PlanesSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumPlanes: %i. \n", size / sizeof(plane));
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", sizeof(plane));
-    PRINTF(4)("BSP FILE: PlanesOffset: %i. \n", offset);
-    this->numPlanes = size/sizeof(plane);
-    this->planes = new plane [this->numPlanes];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->planes, size);
-
-    // Get the Leafs
-    offset = SDL_SwapLE32(((int *)(header) )[10]);
-    size    = SDL_SwapLE32(((int *)(header))[11]);
-    PRINTF(4)("BSP FILE: LeaveSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumLeaves: %i. \n", size / sizeof(leaf));
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % sizeof(leaf));
-    PRINTF(4)("BSP FILE: LeaveOffset: %i. \n", offset);
-    this->numLeafs = size/sizeof(leaf);
-    this->leaves = new leaf [this->numLeafs];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->leaves, size);
-
-    // Get the Models
-    offset = SDL_SwapLE32(((int *)(header))[16]);
-    size    = SDL_SwapLE32(((int *)(header))[17]);
-    PRINTF(4)("BSP FILE: ModelsSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumModels: %i. \n", size / sizeof(model));
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % sizeof(model));
-    PRINTF(4)("BSP FILE: ModelsOffset: %i. \n", offset);
-    this->numBspModels = size/sizeof(model);
-    this->bspModels = new model [this->numBspModels];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->bspModels, size);
-
-    // Get the leafFaces
-    offset = SDL_SwapLE32(((int *)(header))[12]);
-    size    = SDL_SwapLE32(((int *)(header))[13]);
-    PRINTF(4)("BSP FILE: leafFacesSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumleafFaces: %i. \n", size / 4);
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % 4);
-    PRINTF(4)("BSP FILE: leafFacesOffset: %i. \n", offset);
-    this->numLeafFaces = size/4;
-    this->leafFaces = new char [size];
-    bspFile.seekg(offset);
-    bspFile.read(this->leafFaces, size);
-
-    // Get the leafBrushes
-    offset = SDL_SwapLE32(((int *)(header))[14]);
-    size    = SDL_SwapLE32(((int *)(header))[15]);
-    PRINTF(4)("BSP FILE: leafBrushesSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumleafBrushes: %i. \n", size / 4);
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % 4);
-    PRINTF(4)("BSP FILE: leafBrushesOffset: %i. \n", offset);
-    this->numLeafBrushes = size/4;
-    this->leafBrushes = new char [size];
-    bspFile.seekg(offset);
-    bspFile.read(this->leafBrushes, size);
-
-    // Get the brushes
-    offset = SDL_SwapLE32(((int *)(header))[18]);
-    size    = SDL_SwapLE32(((int *)(header))[19]);
-    PRINTF(4)("BSP FILE: BrushesSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumBrushes: %i. \n", size / sizeof(brush));
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % sizeof(brush));
-    PRINTF(4)("BSP FILE: BrushesOffset: %i. \n", offset);
-    this->brushes = new brush [size/sizeof(brush)];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->brushes, size);
-
-    // Get the brushSides
-    offset =   SDL_SwapLE32(((int *)(header))[20]);
-    size    = SDL_SwapLE32(((int *)(header))[21]);
-    PRINTF(4)("BSP FILE: BrushSidesSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumBrushSides: %i. \n", size / 8);
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % 8);
-    PRINTF(4)("BSP FILE: BrushSidesOffset: %i. \n", offset);
-    this->numBrushSides = size/sizeof(brushside);
-    this->brushSides = new brushside [this->numBrushSides];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->brushSides, size);
-
-    // Get the Vertice
-    offset = SDL_SwapLE32(((int *)(header))[22]);
-    size    = SDL_SwapLE32(((int *)(header))[23]);
-    PRINTF(4)("BSP FILE: VerticeSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumVertice: %i. \n", size / 44);
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % 44);
-    PRINTF(4)("BSP FILE: VerticeOffset: %i. \n", offset);
-    this->numVertex = size/44;
-    this->vertice = new char [size];
-    bspFile.seekg(offset);
-    bspFile.read(this->vertice, size);
-
-    // Get the MeshVerts
-    offset = SDL_SwapLE32(((int *)(header))[24]);
-    size    = SDL_SwapLE32(((int *)(header))[25]);
-    PRINTF(4)("BSP FILE: MeshVertsSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumMeshVerts: %i. \n", size / sizeof(meshvert));
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % sizeof(meshvert));
-    PRINTF(4)("BSP FILE: MeshVertsOffset: %i. \n", offset);
-    this->meshverts = new meshvert [size / sizeof(meshvert)];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->meshverts, size);
-
-    // Get the Faces
-    offset = SDL_SwapLE32(((int *)(header))[28]);
-    size    = SDL_SwapLE32(((int *)(header))[29]);
-    PRINTF(4)("BSP FILE: FacesSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumFaces: %i. \n", size / sizeof(face));
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % sizeof(face));
-    PRINTF(4)("BSP FILE: FacesOffset: %i. \n", offset);
-    this->numFaces = size/sizeof(face);
-    this->faces = new face [this->numFaces];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->faces, size);
-
-    //Get the lightmaps
-    offset = SDL_SwapLE32(((int *)(header))[30]);
-    size    = SDL_SwapLE32(((int *)(header))[31]);
-    this->numLightMaps = size/ sizeof(lightmap);
-    this->lightMaps = new lightmap [this->numLightMaps];
-    bspFile.seekg(offset);
-    bspFile.read((char*)this->lightMaps, size);
-
-
-    // Get the Visdata
-    offset = SDL_SwapLE32(((int *)(header))[34]);
-    size    = SDL_SwapLE32(((int *)(header))[35]);
-
-    this->visData = new char [size];
-    bspFile.seekg(offset);
-    bspFile.read(this->visData, size);
-
-    PRINTF(4)("BSP FILE: VisDataSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumVisData: %i. \n", size /1 - 8);
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % 1);
-    PRINTF(4)("BSP FILE: VisDataOffset: %i. \n", offset);
-
-    // Get the Textures
-    offset = SDL_SwapLE32(((int *)(header))[4]);
-    size    = SDL_SwapLE32(((int *)(header))[5]);
-
-    this->textures= new char [size];
-    bspFile.seekg(offset);
-    bspFile.read(this->textures, size);
-
-    PRINTF(4)("BSP FILE: TextureSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumTextures: %i. \n", size /72);
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % 72);
-    PRINTF(4)("BSP FILE: TextureOffset: %i. \n", offset);
-    this->numTextures = size/72;
-
-    bspFile.close();
-
-    for(int i = 0 ; i < this->numTextures; i++)
-      PRINTF(4)("BSP FILE: Texture 0: %s. \n", &this->textures[8+ 72*i]);
-    this->load_textures();
-
-    // Load the lightMaps
-    this->glLightMapTextures = new GLuint[this->numLightMaps];
-    for(int i = 0; i < this->numLightMaps; i++)
-      this->glLightMapTextures[i] = this->loadLightMapToGL(this->lightMaps[i]);
-
-    //Create white texture for if no lightmap specified
-    glGenTextures(1, &this->whiteLightMap);
-    glBindTexture(GL_TEXTURE_2D, this->whiteLightMap);
-        //Create texture
-    this->whiteTexture[0]=255;
-    this->whiteTexture[1]=255;
-    this->whiteTexture[2]=255;
-
-    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
-    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_R, GL_REPEAT);
-    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
-    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
-
-    glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_PRIORITY, 2);
-
-
-
-    /* control the mipmap levels */
-    glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MIN_LOD, 5);
-    glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MAX_LOD, 0);
-
-    /* build the Texture  OpenGL V >= 1.1 */
-    glTexImage2D(GL_TEXTURE_2D,
-                 0,
-                 GL_RGBA8,
-                 1,
-                 1,
-                 0,
-                 GL_RGB,
-                 GL_UNSIGNED_BYTE,
-                 (const GLvoid *)&(this->whiteTexture));
-
-   gluBuild2DMipmaps(   GL_TEXTURE_2D, GL_RGBA8, 1, 1,
-                      GL_RGB, GL_UNSIGNED_BYTE,(const GLvoid *) &(this->whiteTexture));
-
-
-
-    // Get the number of patches
-    this->numPatches = 0;
-    this->patchOffset   = 0;
-
-    for( int i = 0; i < this->numFaces; i++) {
-      face& cFace = ((face *)(this->faces))[i];
-      if (SDL_SwapLE32(cFace.type) == 2)
-        this->numPatches += (SDL_SwapLE32(cFace.size[0]) -1 ) / 2  * (SDL_SwapLE32(cFace.size[1]) -1) / 2;
-    }
-
-    // Allocate Memory
-    this->patchVertice = new char[8*8*44*(this->numPatches+10)];
-    this->patchIndexes = new char[7*8*2*4*(this->numPatches+10)];
- // this->patchRowIndexes = new int*[7*4*this->numPatches]; Not needed?
-    this->patchTrianglesPerRow = new char[7*4*this->numPatches];
-    this->VertexArrayModels  = new VertexArrayModel*[this->numPatches];
-
-    PRINTF(4)("BSP FILE:NumberOfPatches: %i . \n", numPatches);
-
-    this->swapAllBspCoordinates();
-
-    // Do tesselation for all Faces of type 2
-    for( int i = 0; i < this->numFaces; i++) {
-      if (SDL_SwapLE32((this->faces)[i].type) == 2)
-        this->tesselate(i);
-    }
-
-    PRINTF(4)("BSP FILE:PatchOffset: %i . \n", this->patchOffset);
-
-    return  1;
-  } else {
-    PRINTF(4)("BSP FILE: Datei nicht gefunden. \n");
-    return -1;
-  }
-
-
-
+	this->scale = 1.0;
+
+	size_t slurpedBytes;
+	string theBSPFile( name );
+	file.setFileName( theBSPFile );
+	if (file.exists() && file.open( File::ReadOnly ) ) {
+    	PRINTF(0)("BSP FILE: Datei %s gefunden. \n", name);
+    	
+		//BSP-Files have little endian order.
+		file.setByteorder( LittleEndian );
+		file.read( HEADER_SEMANTICS, (void*)&header, slurpedBytes );
+		if ( header.version != 46 ) {
+			PRINTF(0)("BSP FILE: Wrong BSPVersion. We only handle 0x2e-files!\n");   
+			//!< now, we should do some error handling		
+			return ( -1 );
+		}
+		readEntities();
+		readTextures();
+		readPlanes();
+		readNodes();
+		readLeafs(); readLeafFaces(); readLeafBrushes(); 
+		readModels(); 
+		readVertices(); readMeshVerts();
+		readBrushSides(); readBrushes();
+		readEffects();
+		readFaces();
+		readLightmaps(); readLightvols();
+		readVisdata(	
+    	file.close();
+
+	    for(int i = 0 ; i < this->numTextures; i++)
+	    	PRINTF(4)("BSP FILE: Texture 0: %s. \n", &this->textures[8+ 72*i]);
+	    this->load_textures();
+
+	    // Load the lightMaps
+	    this->glLightMapTextures = new GLuint[this->numLightMaps];
+	    for(int i = 0; i < this->numLightMaps; i++)
+	    	this->glLightMapTextures[i] = this->loadLightMapToGL(this->lightMaps[i]);
+
+	    //Create white texture for if no lightmap specified
+	    glGenTextures(1, &this->whiteLightMap);
+	    glBindTexture(GL_TEXTURE_2D, this->whiteLightMap);
+	        //Create texture
+	    this->whiteTexture[0]=255;
+	    this->whiteTexture[1]=255;
+	    this->whiteTexture[2]=255;
+
+	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
+	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_R, GL_REPEAT);
+	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
+	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+
+	    glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_PRIORITY, 2);
+	    /* control the mipmap levels */
+	    glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MIN_LOD, 5);
+	    glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MAX_LOD, 0);
+
+	    /* build the Texture  OpenGL V >= 1.1 */
+	    glTexImage2D(GL_TEXTURE_2D,
+	                 0,
+	                 GL_RGBA8,
+	                 1,
+	                 1,
+	                 0,
+	                 GL_RGB,
+	                 GL_UNSIGNED_BYTE,
+	                 (const GLvoid *)&(this->whiteTexture));
+
+	   gluBuild2DMipmaps(   GL_TEXTURE_2D, GL_RGBA8, 1, 1,
+	                      GL_RGB, GL_UNSIGNED_BYTE,(const GLvoid *) &(this->whiteTexture));
+
+
+
+	    // Get the number of patches
+	    this->numPatches = 0;
+	    this->patchOffset   = 0;
+
+	    for( int i = 0; i < this->numFaces; i++) {
+	      face& cFace = ((face *)(this->faces))[i];
+	      if ( cFace.type  == 2)
+	        this->numPatches += ( cFace.size[0] -1 ) / 2  * ( cFace.size[1] -1 ) / 2;
+	    }
+
+	    // Allocate Memory
+	    this->patchVertice = new char[8*8*44*(this->numPatches+10)];
+	    this->patchIndexes = new char[7*8*2*4*(this->numPatches+10)];
+	 // this->patchRowIndexes = new int*[7*4*this->numPatches]; Not needed?
+	    this->patchTrianglesPerRow = new char[7*4*this->numPatches];
+	    this->VertexArrayModels  = new VertexArrayModel*[this->numPatches];
+
+	    PRINTF(4)("BSP FILE:NumberOfPatches: %i . \n", numPatches);
+
+	    this->swapAllBspCoordinates();
+
+	    // Do tesselation for all Faces of type 2
+	    for( int i = 0; i < this->numFaces; i++) {
+	      if (  (this->faces)[i].type  == 2)
+	        this->tesselate(i);
+	    }
+
+	    PRINTF(4)("BSP FILE:PatchOffset: %i . \n", this->patchOffset);
+
+	    return  1;
+  	} else {
+    	PRINTF(0)("BSP FILE: Datei nicht gefunden. \n");
+    	return -1;
+  	}
 }
 
@@ -430,5 +444,5 @@
   char fileName [500];
   char ext [500];
-  struct stat results;
+  //struct stat results;
 
 
@@ -660,7 +674,7 @@
   int      errorCode = 0;           //!< the error code for the texture loading functions
   unsigned int   lightMap;          //!< the OpenGL texture handle
-  int      mipmapLevel = 0;         //!< the maximum mipmap level for this texture
+ /* int      mipmapLevel = 0;         //!< the maximum mipmap level for this texture
   int      mipmapWidth = 0;         //!< the width of the mipmap
-  int      mipmapHight = 0;         //!< the height of the mipmap3
+  int      mipmapHight = 0;         //!< the height of the mipmap3*/
   float sc, scale, temp;
   for(int i = 0; i < 128*128*3 ; i++)
Index: branches/terrain/src/lib/graphics/importer/bsp_file.h
===================================================================
--- branches/terrain/src/lib/graphics/importer/bsp_file.h	(revision 9413)
+++ branches/terrain/src/lib/graphics/importer/bsp_file.h	(revision 9414)
@@ -19,4 +19,5 @@
 
 #include <vector>
+#include "filesys/binary_file.h"
 class SDL_Surface;
 class BspTreeNode;
@@ -27,5 +28,38 @@
 
 
- struct plane
+struct bsp_lump {
+	int			offset;
+	int			length;
+};
+
+enum bsp_lumps {
+	Entities	 	=      0,
+	Textures	 	=      1,
+	Planes 			=      2,
+	Nodes		  	=      3,
+	Leafs		  	=      4,
+	Leaffaces	 	=      5,
+	Leafbrushes		=      6,
+	Models	 		=      7,
+	Brushes	 		=      8,
+	Brushsides		=      9,
+	Vertices	 	=     10,
+	Meshverts	 	=     11,
+	Effects		 	=     12,
+	Faces	 		=     13,
+	Lightmaps	 	=     14,
+	Lightvols	 	=     15,
+	Visdata			=     16
+};
+
+struct bsp_header {
+	// The magic number always "IBSP"
+	char		magic[4];
+	// The version, 0x2e for quake 3 models 
+	int			version;
+	bsp_lump	lumps[17];
+};
+
+struct plane
 {
   float x;     //!< 1st component of the plane's normal
@@ -34,4 +68,5 @@
   float d;     //!< distance of the plane to the origin
 };
+
 
 typedef struct
@@ -82,4 +117,5 @@
 }
 brushside;
+
 
 struct face
@@ -101,4 +137,5 @@
 } ;
 
+
 typedef struct
 {
@@ -130,5 +167,4 @@
 }
 AMat;
-
 typedef struct
 {
@@ -144,4 +180,5 @@
 }
 BspTexture;
+
 
 class BspFile
@@ -162,57 +199,75 @@
 
 private:
-  BspTreeNode* root;
-  char header [ 280 ];       //!< Buffer for header of BSP-File
-  node* nodes;               //!< Buffer to store BSP-Tree-Nodes
-  leaf* leaves;              //!< Buffer to store BSP-Tree-Leaves
-  plane* planes;             //!< Buffer to store planes separateing the space
-  model* bspModels;          //!< Buffer to store BSP-Model-List
-  char* leafFaces;           //!< Buffer to store leafFaces
-  face* faces;               //!<
-  char* leafBrushes;         //!< Buffer to store brush indice
-  brush* brushes;            //!< Buffer to store  brushes
-  brushside* brushSides;     //!<
-  char* vertice;             //!<
-  meshvert* meshverts;       //!< Buffer to store meshverice
-  char* visData;             //!< Buffer to store visibility data
-  char* textures;            //!< Holds all the texture filename strings
-  char* patchVertice;        //!<
-  char* patchIndexes;
-  char* patchTrianglesPerRow;
-  lightmap* lightMaps;       //!< Buffer to store lightmap-images
-
-
-  int** patchRowIndexes;
-  VertexArrayModel** VertexArrayModels; 
-  int patchOffset;
-
-  int numNodes;
-  int numLeafs;
-  int numVertex;
-  int numPlanes;
-  int numBspModels;
-  int numLeafFaces;
-  int numFaces;
-  int numLeafBrushes;
-  int numTextures;
-  int numPatches;
-  int numBrushSides;
-  int numLightMaps;
-  
-  float  scale;
-
-  BspTreeNode* build_tree_rec( int i );
-  unsigned int loadLightMapToGL(lightmap&);
-  AMat* Materials;
-  unsigned int* glLightMapTextures;
-  unsigned int whiteLightMap;
-  unsigned char whiteTexture[3];
-  void swapAllBspCoordinates();
-  void swapCoords(int * array);
-  void swapCoords(float * array);
-  SDL_Surface* testSurf;
-
- 
-  ::std::vector<MoviePlayer* > MovieMaterials; //!< Movieplayer Materials
-};
-
+	void readEntities();
+	void readTextures();
+	void readPlanes();
+	void readNodes();
+	void readLeafs();
+	void readLeafFaces();
+	void readLeafBrushes();
+	void readBrushSides();
+	void readModels();
+	void readBrushes();
+	void readVertices();
+	void readMeshVerts();
+	void readEffects();
+	void readFaces();
+	void readLightmaps();
+	void readLightvols();
+	void readVisdata();
+  	BinaryFile file;
+	BspTreeNode* root;
+	bsp_header header;       	 //!< Buffer for header of BSP-File
+	node* nodes;               //!< Buffer to store BSP-Tree-Nodes
+	leaf* leaves;              //!< Buffer to store BSP-Tree-Leaves
+	plane* planes;             //!< Buffer to store planes separateing the space
+	model* bspModels;          //!< Buffer to store BSP-Model-List
+	char* leafFaces;           //!< Buffer to store leafFaces
+	face* faces;               //!<
+	char* leafBrushes;         //!< Buffer to store brush indice
+	brush* brushes;            //!< Buffer to store  brushes
+	brushside* brushSides;     //!<
+	char* vertice;             //!<
+	meshvert* meshverts;       //!< Buffer to store meshverice
+	char* visData;             //!< Buffer to store visibility data
+	char* textures;            //!< Holds all the texture filename strings
+	char* patchVertice;        //!<
+	char* patchIndexes;
+	char* patchTrianglesPerRow;
+	lightmap* lightMaps;       //!< Buffer to store lightmap-images
+
+
+	int** patchRowIndexes;
+	VertexArrayModel** VertexArrayModels; 
+	int patchOffset;
+
+	int numNodes;
+	int numLeafs;
+	int numVertex;
+	int numPlanes;
+	int numBspModels;
+	int numLeafFaces;
+	int numFaces;
+	int numLeafBrushes;
+	int numTextures;
+	int numPatches;
+	int numBrushSides;
+	int numLightMaps;
+
+	float  scale;
+
+	BspTreeNode* build_tree_rec( int i );
+	unsigned int loadLightMapToGL(lightmap&);
+	AMat* Materials;
+	unsigned int* glLightMapTextures;
+	unsigned int whiteLightMap;
+	unsigned char whiteTexture[3];
+	void swapAllBspCoordinates();
+	void swapCoords(int * array);
+	void swapCoords(float * array);
+	SDL_Surface* testSurf;
+
+
+	::std::vector<MoviePlayer* > MovieMaterials; //!< Movieplayer Materials
+};
+
Index: branches/terrain/src/lib/graphics/importer/bsp_manager.cc
===================================================================
--- branches/terrain/src/lib/graphics/importer/bsp_manager.cc	(revision 9413)
+++ branches/terrain/src/lib/graphics/importer/bsp_manager.cc	(revision 9414)
@@ -199,5 +199,6 @@
   this->outputFraction = 1.0f;
 
-  if ( viscluster < 0  || ((int *)(this->bspFile->header))[35] == 0 )  //!< if (sizeof(Visdata) == 0)
+  if ( ( viscluster < 0  ) ||
+ 		( bspFile->header.lumps[Visdata].length == 0 ) )  //!< if (sizeof(Visdata) == 0)
   {
 
Index: branches/terrain/src/lib/graphics/importer/md2/md2Model.cc
===================================================================
--- branches/terrain/src/lib/graphics/importer/md2/md2Model.cc	(revision 9413)
+++ branches/terrain/src/lib/graphics/importer/md2/md2Model.cc	(revision 9414)
@@ -17,5 +17,12 @@
 #include "md2Model.h"
 #include "material.h"
-
+#include "config.h"
+#ifdef HAVE_SDL_SDL_H
+#include <SDL/SDL.h>
+#include <SDL/SDL_endian.h>
+#else
+#include <SDL.h>
+#include <SDL_endian.h>
+#endif
 #include "debug.h"
 #include "util/loading/resource_manager.h"
@@ -67,5 +74,21 @@
   };
 
-
+#ifdef SDL_LIL_ENDIAN
+#define BULK_CONV( _ptr, _num ) do { \
+	int  _cnt = _num;\
+	int* _iptr = (int*)_ptr;\
+	for( int _l = 0; _l<_cnt; ++_l )\
+		_iptr[_l] = SDL_SwapLE32( _iptr[_l] );\
+} while( 0 )
+#define BULK_CONV16( _ptr, _num ) do { \
+	short  _cnt = _num;\
+	short* _iptr = (short*)_ptr;\
+	for( int _l = 0; _l<_cnt; ++_l )\
+		_iptr[_l] = SDL_SwapLE16( _iptr[_l] );\
+} while( 0 )
+#else
+#define BULK_CONV( _ptr, _num )
+#define BULK_CONV16( _ptr, _num )
+#endif
 
 /********************************************************************************
@@ -468,6 +491,7 @@
   this->header = new MD2Header;
   fread(this->header, 1, sizeof(MD2Header), pFile);
+	BULK_CONV( this->header, sizeof(MD2Header)/4 );
   /* check for the header version: make sure its a md2 file :) */
-  if( unlikely(this->header->version != MD2_VERSION) && unlikely(this->header->ident != MD2_IDENT))
+  if( unlikely( this->header->version != MD2_VERSION) && unlikely( this->header->ident != MD2_IDENT))
     {
       PRINTF(1)("Couldn't load file %s: invalid file format: stop loading\n", fileName.c_str());
@@ -475,5 +499,5 @@
     }
 
-  this->fileName =fileName;
+  this->fileName = fileName;
   /* got the data: map it to locals */
   this->numFrames = this->header->numFrames;
@@ -494,18 +518,26 @@
   fseek(pFile, this->header->offsetFrames, SEEK_SET);
   fread(buffer, this->header->frameSize, this->numFrames, pFile);
+	//BULK_CONV( buffer, this->header->frameSize*this->numFrames*sizeof(char)/4 );
   /* read opengl commands */
   fseek(pFile, this->header->offsetGlCommands, SEEK_SET);
+
   fread(this->pGLCommands, sizeof(int), this->numGLCommands, pFile);
+	BULK_CONV( this->pGLCommands, this->numGLCommands );
   /* triangle list */
   fseek(pFile, this->header->offsetTriangles, SEEK_SET);
-  fread(this->pTriangles, sizeof(sTriangle), this->numTriangles, pFile);
+  fread(this->pTriangles, sizeof(sTriangle), this->numTriangles, pFile);	
+	BULK_CONV16( this->pTriangles, this->numTriangles*sizeof(sTriangle)/2 );
+
   /*  read in texture coordinates */
   fseek(pFile, this->header->offsetTexCoords, SEEK_SET);
   fread(this->pTexCoor, sizeof(sTexCoor), this->numTexCoor, pFile);
-
+	BULK_CONV16( this->pTexCoor, this->numTexCoor*sizeof(sTexCoor)/2 );
 
   for(int i = 0; i < this->numFrames; ++i)
     {
       frame = (sFrame*)(buffer + this->header->frameSize * i);
+			//Convert the translate and scale Vec3D if needed.
+			BULK_CONV( frame, 6 );
+			BULK_CONV( frame->pVertices, 3 );
       pVertex = this->pVertices + this->numVertices  * i;
       pNormals = this->pLightNormals + this->numVertices * i;
